# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/13
import json
import os
import random
import shutil
import sys
import time
import requests
import urllib3

sys.path.append(os.getcwd())
from common.common import Common
from common.scheduling_db import MysqlHelper
from common.publish import Publish
from common.feishu import Feishu
from common.public import filter_word
proxies = {"http": None, "https": None}


class XiaoniangaoFollow:
    platform = "小年糕"
    # 小程序个人主页视频列表翻页参数
    next_t = None

    # 基础门槛规则
    @staticmethod
    def download_rule(video_dict):
        """
        下载视频的基本规则
        :param video_dict: 视频信息，字典格式
        :return: 满足规则，返回 True；反之，返回 False
        """
        # 视频时长
        if int(float(video_dict['duration'])) >= 40:
            # 宽或高
            if int(video_dict['video_width']) >= 0 or int(video_dict['video_height']) >= 0:
                # 播放量
                if int(video_dict['play_cnt']) >= 500:
                    # 分享量
                    if int(video_dict['share_cnt']) >= 0:
                        return True
                    else:
                        return False
                else:
                    return False
            else:
                return False
        else:
            return False

    # 从云文档获取关注用户列表
    @classmethod
    def get_users(cls):
            # follow_sheet = Feishu.get_values_batch("follow", "xiaoniangao", "oNpThi")
            # user_list = []
            # for i in range(1, len(follow_sheet)):
            #     profile_id = follow_sheet[i][0]
            #     profile_mid = follow_sheet[i][1]
            #     user_name = follow_sheet[i][2]
            #     user_dict = {
            #         "profile_id": str(profile_id),
            #         "profile_mid": str(profile_mid),
            #         "user_name": user_name,
            #     }
            #     user_list.append(user_dict)
            # print(len(user_list))
            # print(user_list)

        user_list = [{'profile_id': '43549964', 'profile_mid': '116311065', 'user_name': '青峰明月老人'}, {'profile_id': '43486474', 'profile_mid': '1113556014', 'user_name': '好人一生平安'}, {'profile_id': '43590330', 'profile_mid': '192501730', 'user_name': '风轻云淡'}, {'profile_id': '43559741', 'profile_mid': '90261331', 'user_name': '歌一曲'}, {'profile_id': '43785654', 'profile_mid': '104703232', 'user_name': '涧欣'}, {'profile_id': '44211463', 'profile_mid': '1149063512', 'user_name': '美食分享'}, {'profile_id': '46661040', 'profile_mid': '293457861', 'user_name': '阿妞'}, {'profile_id': '46731019', 'profile_mid': '1059483000', 'user_name': '早睡早起锻炼身体'}, {'profile_id': '46644244', 'profile_mid': '609255292', 'user_name': '雨太漫长'}, {'profile_id': '46553912', 'profile_mid': '1160417287', 'user_name': '葛锡琴'}, {'profile_id': '46802824', 'profile_mid': '1157645694', 'user_name': '留白'}, {'profile_id': '46795509', 'profile_mid': '1161593368', 'user_name': '绒花漫舞'}, {'profile_id': '46837469', 'profile_mid': '1160417275', 'user_name': '苏超灵'}, {'profile_id': '46830553', 'profile_mid': '1160417336', 'user_name': '山里红'}, {'profile_id': '50541284', 'profile_mid': '1210725734', 'user_name': '语琴'}, {'profile_id': '50541428', 'profile_mid': '1222976096', 'user_name': '血性娘子'}, {'profile_id': '50364411', 'profile_mid': '1192924729', 'user_name': '好运莲莲'}, {'profile_id': '50499182', 'profile_mid': '329676836', 'user_name': '花好月圆'}, {'profile_id': '50449938', 'profile_mid': '341183833', 'user_name': '花开富贵'}, {'profile_id': '50199770', 'profile_mid': '1166029432', 'user_name': '兰花草1'}, {'profile_id': '50299362', 'profile_mid': '1013092427', 'user_name': '感悟人生'}, {'profile_id': '50539176', 'profile_mid': '1203033756', 'user_name': '风之别鹤'}, {'profile_id': '50541092', 'profile_mid': '1237693278', 'user_name': '莲心'}, {'profile_id': '50523015', 'profile_mid': '260159327', 'user_name': '微笑😊123'}, {'profile_id': '50216970', 'profile_mid': '1219153129', 'user_name': '秋夕'}, {'profile_id': '50286181', 'profile_mid': '1113733998', 'user_name': '上善若水'}, {'profile_id': '50505135', 'profile_mid': '185546', 'user_name': '秋水揽星河'}, {'profile_id': '50555007', 'profile_mid': '1113739184', 'user_name': '淡墨青衫'}, {'profile_id': '50500343', 'profile_mid': '1072539904', 'user_name': '微笑向明天'}, {'profile_id': '50628735', 'profile_mid': '1142824266', 'user_name': '清爽'}, {'profile_id': '50580367', 'profile_mid': '26055443', 'user_name': '玉儿Syy'}, {'profile_id': '50585024', 'profile_mid': '1105334217', 'user_name': '老树开花🌸'}, {'profile_id': '50380683', 'profile_mid': '63682047', 'user_name': '海王岛浩哥'}, {'profile_id': '46386724', 'profile_mid': '271535337', 'user_name': '雪梅'}, {'profile_id': '50636398', 'profile_mid': '237071458', 'user_name': '看花人'}, {'profile_id': '50624991', 'profile_mid': '1202244309', 'user_name': '无关风月'}, {'profile_id': '50561528', 'profile_mid': '1134790664', 'user_name': '老有所乐'}, {'profile_id': '50612235', 'profile_mid': '1162974507', 'user_name': '花素千昔'}, {'profile_id': '50933310', 'profile_mid': '1237661365', 'user_name': '淡淡浅香'}, {'profile_id': '50492961', 'profile_mid': '1160417339', 'user_name': '胡淑华'}, {'profile_id': '49965729', 'profile_mid': '1160417117', 'user_name': '百姓生活'}, {'profile_id': '50928693', 'profile_mid': '1163097085', 'user_name': '多福'}, {'profile_id': '50819153', 'profile_mid': '224365299', 'user_name': '欢天喜地'}, {'profile_id': '51510752', 'profile_mid': '1160417314', 'user_name': '郝建兵'}, {'profile_id': '51470002', 'profile_mid': '631317964', 'user_name': '九牛二虎'}, {'profile_id': '51466430', 'profile_mid': '177806025', 'user_name': '越来越好'}, {'profile_id': '51480157', 'profile_mid': '1000526700', 'user_name': '光伯伯'}, {'profile_id': '51396620', 'profile_mid': '1160417243', 'user_name': '亚萍'}, {'profile_id': '51538137', 'profile_mid': '154002316', 'user_name': 'hua jean-pierre   許遵訓'}, {'profile_id': '51533676', 'profile_mid': '197908577', 'user_name': '萍水相逢'}, {'profile_id': '51488254', 'profile_mid': '153685063', 'user_name': '英勇'}, {'profile_id': '51425929', 'profile_mid': '1161593426', 'user_name': '百年字号'}, {'profile_id': '51514370', 'profile_mid': '1198361106', 'user_name': '品味人生'}, {'profile_id': '51405010', 'profile_mid': '1161593390', 'user_name': '低调生活'}, {'profile_id': '51535995', 'profile_mid': '690938173', 'user_name': '世界风'}, {'profile_id': '51468900', 'profile_mid': '1242534599', 'user_name': '人生如茶'}, {'profile_id': '51489772', 'profile_mid': '269038284', 'user_name': '韵律'}, {'profile_id': '51377241', 'profile_mid': '194287386', 'user_name': '霹雳雷天发'}, {'profile_id': '51538527', 'profile_mid': '1064479786', 'user_name': '鑫'}, {'profile_id': '51365161', 'profile_mid': '1161593351', 'user_name': '黄金三十分'}, {'profile_id': '51527297', 'profile_mid': '1163011474', 'user_name': '指日东升'}, {'profile_id': '51356555', 'profile_mid': '76036942', 'user_name': '利剑'}, {'profile_id': '51382702', 'profile_mid': '1160417349', 'user_name': '丽丽'}, {'profile_id': '51536925', 'profile_mid': '1160417133', 'user_name': '福海'}, {'profile_id': '51525148', 'profile_mid': '1160417333', 'user_name': '君子兰'}, {'profile_id': '51530896', 'profile_mid': '1162996019', 'user_name': '你好，朋友'}, {'profile_id': '51532418', 'profile_mid': '1162998153', 'user_name': '旭日东升'}, {'profile_id': '51329950', 'profile_mid': '285062559', 'user_name': '阿静'}, {'profile_id': '51512535', 'profile_mid': '114981390', 'user_name': '泽南'}, {'profile_id': '51480066', 'profile_mid': '1160417334', 'user_name': '克平'}, {'profile_id': '51520908', 'profile_mid': '1161593408', 'user_name': '永生'}, {'profile_id': '51496944', 'profile_mid': '1160417145', 'user_name': '一生快乐'}, {'profile_id': '51511833', 'profile_mid': '1105154277', 'user_name': '老周.物流全国.'}, {'profile_id': '51515937', 'profile_mid': '1178673137', 'user_name': '风起风落'}, {'profile_id': '51539903', 'profile_mid': '1175023459', 'user_name': '花开福贵 &吉祥'}, {'profile_id': '51394812', 'profile_mid': '1160417173', 'user_name': '尔东'}, {'profile_id': '51512298', 'profile_mid': '22171304', 'user_name': '张杰真'}, {'profile_id': '51472642', 'profile_mid': '175855074', 'user_name': '张顺淑'}, {'profile_id': '51548416', 'profile_mid': '1116847111', 'user_name': '沁水百合'}, {'profile_id': '51456595', 'profile_mid': '1075862992', 'user_name': '永保青春'}, {'profile_id': '51502433', 'profile_mid': '1162980250', 'user_name': '午夜想念'}, {'profile_id': '51495781', 'profile_mid': '1162961480', 'user_name': '快乐每一天'}, {'profile_id': '51527180', 'profile_mid': '1161593427', 'user_name': '彩云追月'}, {'profile_id': '51537082', 'profile_mid': '1163005063', 'user_name': '峥嵘岁月'}, {'profile_id': '51510904', 'profile_mid': '64295407', 'user_name': '文文'}, {'profile_id': '51497047', 'profile_mid': '59349938', 'user_name': '老马识途'}, {'profile_id': '51544604', 'profile_mid': '1160417260', 'user_name': '星'}, {'profile_id': '51411909', 'profile_mid': '801020924', 'user_name': '相思鸟'}, {'profile_id': '51525860', 'profile_mid': '1160417222', 'user_name': '老来得福'}, {'profile_id': '51540902', 'profile_mid': '1163003217', 'user_name': '银发中年'}, {'profile_id': '51526760', 'profile_mid': '295640510', 'user_name': '阿中'}, {'profile_id': '51529247', 'profile_mid': '674650199', 'user_name': '张恩培'}, {'profile_id': '51540032', 'profile_mid': '18103420', 'user_name': '吴希孟'}, {'profile_id': '51491818', 'profile_mid': '1162991035', 'user_name': '幸福每一天'}, {'profile_id': '51539843', 'profile_mid': '210721352', 'user_name': '掉地人参果'}, {'profile_id': '51521237', 'profile_mid': '1160417237', 'user_name': '山野村夫'}, {'profile_id': '51531438', 'profile_mid': '103235841', 'user_name': '开心'}, {'profile_id': '51528239', 'profile_mid': '1160417288', 'user_name': '戴玉亭'}, {'profile_id': '51542817', 'profile_mid': '126121769', 'user_name': '芳芳'}, {'profile_id': '51541108', 'profile_mid': '287637208', 'user_name': '心无旁骛'}, {'profile_id': '51462517', 'profile_mid': '247008734', 'user_name': '华'}, {'profile_id': '51543209', 'profile_mid': '1214482340', 'user_name': '丽'}, {'profile_id': '51509548', 'profile_mid': '1162977406', 'user_name': '绚丽多彩'}, {'profile_id': '51536733', 'profile_mid': '1161593366', 'user_name': '夕阳红'}, {'profile_id': '51519407', 'profile_mid': '1122750580', 'user_name': '幸福满堂'}, {'profile_id': '51459413', 'profile_mid': '348958961', 'user_name': '段平清'}, {'profile_id': '51487820', 'profile_mid': '605290310', 'user_name': '青青'}, {'profile_id': '51469080', 'profile_mid': '131475097', 'user_name': '手宝'}, {'profile_id': '51426171', 'profile_mid': '196597807', 'user_name': '妙'}, {'profile_id': '51470293', 'profile_mid': '78386273', 'user_name': '芳草'}, {'profile_id': '51505305', 'profile_mid': '172977522', 'user_name': '伟星'}, {'profile_id': '51541167', 'profile_mid': '1100776170', 'user_name': '闪电⚡️'}, {'profile_id': '51391450', 'profile_mid': '982518039', 'user_name': '吕梁'}, {'profile_id': '51529786', 'profile_mid': '168833501', 'user_name': '：shen. ser'}, {'profile_id': '51416422', 'profile_mid': '376557509', 'user_name': '于孝震'}, {'profile_id': '51342944', 'profile_mid': '556796156', 'user_name': '☀吉祥☀'}, {'profile_id': '51536144', 'profile_mid': '1162956349', 'user_name': '凤舞九天'}, {'profile_id': '51533164', 'profile_mid': '153787914', 'user_name': '红梅'}, {'profile_id': '51450974', 'profile_mid': '20396528', 'user_name': '学友'}, {'profile_id': '51512622', 'profile_mid': '35883962', 'user_name': '珎珎'}, {'profile_id': '51525737', 'profile_mid': '69546032', 'user_name': '欣然'}, {'profile_id': '51414093', 'profile_mid': '1154645646', 'user_name': '老中医'}, {'profile_id': '51372351', 'profile_mid': '154481426', 'user_name': '寻花'}, {'profile_id': '51511869', 'profile_mid': '1162958849', 'user_name': '保持微笑'}, {'profile_id': '51367397', 'profile_mid': '173682337', 'user_name': '莲'}, {'profile_id': '51494361', 'profile_mid': '1161593403', 'user_name': '红叶'}, {'profile_id': '51352260', 'profile_mid': '31040287', 'user_name': '52部队'}, {'profile_id': '51430672', 'profile_mid': '69886497', 'user_name': '张俊宽'}, {'profile_id': '51440076', 'profile_mid': '1186145367', 'user_name': '金光'}, {'profile_id': '51431733', 'profile_mid': '112830331', 'user_name': '幸福安康'}, {'profile_id': '51466969', 'profile_mid': '131962346', 'user_name': '丹桂'}, {'profile_id': '51515739', 'profile_mid': '1162950925', 'user_name': '烈火'}, {'profile_id': '51465625', 'profile_mid': '913804992', 'user_name': '荷塘月色'}, {'profile_id': '51508736', 'profile_mid': '30955754', 'user_name': '硕'}, {'profile_id': '51488704', 'profile_mid': '1160417201', 'user_name': '伴迪伴你'}, {'profile_id': '51514871', 'profile_mid': '1161593379', 'user_name': '心无界'}, {'profile_id': '51517906', 'profile_mid': '1160417268', 'user_name': '宏蕴'}, {'profile_id': '51517169', 'profile_mid': '1163601308', 'user_name': '今日祝福'}, {'profile_id': '51382334', 'profile_mid': '1177277385', 'user_name': '丝花'}, {'profile_id': '51606330', 'profile_mid': '912444460', 'user_name': 'pan'}, {'profile_id': '51574573', 'profile_mid': '18628461', 'user_name': '镇华'}, {'profile_id': '51576665', 'profile_mid': '238020228', 'user_name': '杏子'}, {'profile_id': '51577353', 'profile_mid': '746152129', 'user_name': '南極'}, {'profile_id': '51619591', 'profile_mid': '169107521', 'user_name': '天南海北'}, {'profile_id': '51558453', 'profile_mid': '37660529', 'user_name': '歌哥'}, {'profile_id': '51565261', 'profile_mid': '7455950', 'user_name': '东北人'}, {'profile_id': '51549436', 'profile_mid': '173754665', 'user_name': '68《电波》'}, {'profile_id': '51596064', 'profile_mid': '334594004', 'user_name': '许 霞 客'}, {'profile_id': '51562005', 'profile_mid': '124746031', 'user_name': '新毛笔'}, {'profile_id': '51558760', 'profile_mid': '201200932', 'user_name': '岁月静好'}, {'profile_id': '51534579', 'profile_mid': '5369941', 'user_name': '泾渭分明'}, {'profile_id': '51587605', 'profile_mid': '800143421', 'user_name': '渡我'}, {'profile_id': '51541987', 'profile_mid': '156490323', 'user_name': '三国'}, {'profile_id': '51555616', 'profile_mid': '1160417130', 'user_name': '华山论剑'}, {'profile_id': '51471936', 'profile_mid': '246878924', 'user_name': '孙木木'}, {'profile_id': '51596587', 'profile_mid': '330013250', 'user_name': 'Chungen Ju'}, {'profile_id': '51535749', 'profile_mid': '258896502', 'user_name': '小飞象'}, {'profile_id': '51526063', 'profile_mid': '1160417175', 'user_name': '小段段'}, {'profile_id': '51596980', 'profile_mid': '256733182', 'user_name': '崇正庚'}, {'profile_id': '51475303', 'profile_mid': '130126439', 'user_name': '夕阳余晖'}, {'profile_id': '51579715', 'profile_mid': '1163008965', 'user_name': '大漠驼铃'}, {'profile_id': '51517955', 'profile_mid': '297080453', 'user_name': '蓝天白云'}, {'profile_id': '51579777', 'profile_mid': '146924331', 'user_name': '成绩'}, {'profile_id': '51587711', 'profile_mid': '167255646', 'user_name': '指尖芭蕾'}, {'profile_id': '51574471', 'profile_mid': '193552533', 'user_name': '老战士'}, {'profile_id': '51582228', 'profile_mid': '1161593389', 'user_name': '匆匆人生'}, {'profile_id': '51580109', 'profile_mid': '1162954764', 'user_name': '花开有福'}, {'profile_id': '51576191', 'profile_mid': '583250197', 'user_name': '明月'}, {'profile_id': '51424809', 'profile_mid': '1160417162', 'user_name': '冬雪'}, {'profile_id': '51507365', 'profile_mid': '1160417170', 'user_name': '金鑫'}, {'profile_id': '51504566', 'profile_mid': '1160417277', 'user_name': '熊先生'}, {'profile_id': '51478499', 'profile_mid': '1236785994', 'user_name': '奉祥'}, {'profile_id': '51557117', 'profile_mid': '208885032', 'user_name': '善解人意'}, {'profile_id': '51475483', 'profile_mid': '183839316', 'user_name': 'horse'}, {'profile_id': '51558699', 'profile_mid': '812582794', 'user_name': '김학선'}, {'profile_id': '51543823', 'profile_mid': '1160417172', 'user_name': '日出'}, {'profile_id': '51547046', 'profile_mid': '1160417150', 'user_name': '祥哥'}, {'profile_id': '51569091', 'profile_mid': '162704496', 'user_name': '崔德珍'}, {'profile_id': '51538585', 'profile_mid': '201393573', 'user_name': '李裕年'}, {'profile_id': '51511316', 'profile_mid': '9863172', 'user_name': '红绫'}, {'profile_id': '51517359', 'profile_mid': '428192018', 'user_name': '荷月'}, {'profile_id': '51481801', 'profile_mid': '814090755', 'user_name': '聊歌'}, {'profile_id': '51487330', 'profile_mid': '145093442', 'user_name': '郑明国'}, {'profile_id': '51538353', 'profile_mid': '1216082', 'user_name': '连玩'}, {'profile_id': '51573284', 'profile_mid': '262696881', 'user_name': '远'}, {'profile_id': '51490939', 'profile_mid': '1160417343', 'user_name': '五彩缤纷'}, {'profile_id': '51528852', 'profile_mid': '1160417280', 'user_name': '亚～丽'}, {'profile_id': '51573486', 'profile_mid': '555866418', 'user_name': '荣'}, {'profile_id': '51573150', 'profile_mid': '195922263', 'user_name': '思思'}, {'profile_id': '51536141', 'profile_mid': '2324632', 'user_name': '淡'}, {'profile_id': '51573400', 'profile_mid': '85984018', 'user_name': '石头哥'}, {'profile_id': '51530358', 'profile_mid': '1160417230', 'user_name': '娟'}, {'profile_id': '51423634', 'profile_mid': '1160417366', 'user_name': '洁洁'}, {'profile_id': '51415095', 'profile_mid': '276227387', 'user_name': '十月'}, {'profile_id': '51472794', 'profile_mid': '110333218', 'user_name': '罗月泉'}, {'profile_id': '51434083', 'profile_mid': '16503153', 'user_name': '蓝天白云阳光'}, {'profile_id': '51362428', 'profile_mid': '23276114', 'user_name': '智勇'}, {'profile_id': '51562348', 'profile_mid': '23771415', 'user_name': '老自在'}, {'profile_id': '51527231', 'profile_mid': '32290307', 'user_name': '子龙zyg'}, {'profile_id': '51520025', 'profile_mid': '29017863', 'user_name': '长平'}, {'profile_id': '51567095', 'profile_mid': '410251493', 'user_name': '周小编'}, {'profile_id': '51554155', 'profile_mid': '50262268', 'user_name': 'ㄙ力'}, {'profile_id': '51484880', 'profile_mid': '288147906', 'user_name': '凝雪'}, {'profile_id': '51528645', 'profile_mid': '40442332', 'user_name': '我的'}, {'profile_id': '51546110', 'profile_mid': '1160417236', 'user_name': '黄二'}, {'profile_id': '51396591', 'profile_mid': '164230145', 'user_name': '中国的🇨🇳 中'}, {'profile_id': '51564853', 'profile_mid': '43574864', 'user_name': '韦爵爷（韦全盛广州）'}, {'profile_id': '51534462', 'profile_mid': '1195094786', 'user_name': '福如东海'}, {'profile_id': '51548364', 'profile_mid': '41260451', 'user_name': '长寿村ccr1226'}, {'profile_id': '51674661', 'profile_mid': '1087239508', 'user_name': '颖'}, {'profile_id': '50498574', 'profile_mid': '227251181', 'user_name': '樱花红陌上'}, {'profile_id': '50998070', 'profile_mid': '45812341', 'user_name': '宇宙龙'}, {'profile_id': '51517051', 'profile_mid': '33975007', 'user_name': '懋忍者'}, {'profile_id': '50888222', 'profile_mid': '173572675', 'user_name': '余系立'}, {'profile_id': '50773751', 'profile_mid': '1005247', 'user_name': '长乐'}, {'profile_id': '50469333', 'profile_mid': '177860827', 'user_name': '毛映星'}, {'profile_id': '50625670', 'profile_mid': '16866802', 'user_name': '阿文哥'}, {'profile_id': '50530771', 'profile_mid': '132022633', 'user_name': '德兰'}, {'profile_id': '50521985', 'profile_mid': '6903156', 'user_name': '艺丹'}, {'profile_id': '50396968', 'profile_mid': '174184693', 'user_name': '情痴🌴❤️🇨🇳'}, {'profile_id': '50581740', 'profile_mid': '1204204129', 'user_name': '小宝爷爷'}, {'profile_id': '50852888', 'profile_mid': '1163041645', 'user_name': '每一步'}, {'profile_id': '50028439', 'profile_mid': '23642257', 'user_name': '江花剑语'}, {'profile_id': '49754934', 'profile_mid': '1160417204', 'user_name': '一抹微笑'}, {'profile_id': '51723400', 'profile_mid': '330013250', 'user_name': 'ChungenJu'}, {'profile_id': '51305568', 'profile_mid': '1162964081', 'user_name': '老楊开心就好'}, {'profile_id': '51360033', 'profile_mid': '51019095', 'user_name': 'C.Q.P.@&&&'}, {'profile_id': '51271108', 'profile_mid': '54610872', 'user_name': '马到成功'}, {'profile_id': '51311725', 'profile_mid': '69968880', 'user_name': '李全华'}, {'profile_id': '51238277', 'profile_mid': '1160417206', 'user_name': '暖心'}, {'profile_id': '51298601', 'profile_mid': '263815315', 'user_name': '陳坤雄'}, {'profile_id': '51302449', 'profile_mid': '1160417312', 'user_name': '淡泊宁静'}, {'profile_id': '51288732', 'profile_mid': '252962481', 'user_name': '盛文奶奶'}, {'profile_id': '51257079', 'profile_mid': '168108669', 'user_name': '钱文广'}, {'profile_id': '51282915', 'profile_mid': '113343785', 'user_name': '愉悦'}, {'profile_id': '51280015', 'profile_mid': '47771735', 'user_name': '陈国庆'}, {'profile_id': '51216073', 'profile_mid': '1157498248', 'user_name': '天高云淡'}, {'profile_id': '51212926', 'profile_mid': '278762839', 'user_name': '荷韵舞美'}, {'profile_id': '51214452', 'profile_mid': '1160417372', 'user_name': '璐瑶'}, {'profile_id': '51163788', 'profile_mid': '1160417318', 'user_name': '篮精灵'}, {'profile_id': '51217967', 'profile_mid': '302013472', 'user_name': '吴三毛'}, {'profile_id': '51219006', 'profile_mid': '161458173', 'user_name': '李访友'}, {'profile_id': '51116485', 'profile_mid': '142203818', 'user_name': ' 杨安京'}, {'profile_id': '51067925', 'profile_mid': '19503805', 'user_name': '青青原上草'}, {'profile_id': '51188086', 'profile_mid': '1161593430', 'user_name': '夏天'}, {'profile_id': '51091181', 'profile_mid': '176707411', 'user_name': '西北'}, {'profile_id': '51088671', 'profile_mid': '23164486', 'user_name': '田玉明'}, {'profile_id': '51103793', 'profile_mid': '34536244', 'user_name': '相信自己'}, {'profile_id': '51088014', 'profile_mid': '367757852', 'user_name': '益山益水'}, {'profile_id': '51103201', 'profile_mid': '923964638', 'user_name': '有缘相遇'}, {'profile_id': '51056808', 'profile_mid': '33526326', 'user_name': '李庆铉'}, {'profile_id': '51093916', 'profile_mid': '1160417214', 'user_name': '欣欣向上'}, {'profile_id': '51189345', 'profile_mid': '352851214', 'user_name': '好好，爱自己'}, {'profile_id': '51182723', 'profile_mid': '208242501', 'user_name': '凤芝'}, {'profile_id': '51159963', 'profile_mid': '1131244601', 'user_name': '幸福千年金胡'}, {'profile_id': '51186142', 'profile_mid': '124883413', 'user_name': 'yh'}, {'profile_id': '51167553', 'profile_mid': '1004195', 'user_name': '心明'}, {'profile_id': '51059900', 'profile_mid': '1087239508', 'user_name': '冬日暖阳'}, {'profile_id': '51102452', 'profile_mid': '230841899', 'user_name': '保钢'}, {'profile_id': '51120636', 'profile_mid': '53241722', 'user_name': '董淑莲'}, {'profile_id': '51022148', 'profile_mid': '59136015', 'user_name': '夕阳佳雁'}, {'profile_id': '51054327', 'profile_mid': '341707195', 'user_name': '燕琴'}, {'profile_id': '51094909', 'profile_mid': '848442892', 'user_name': '鱼粮'}, {'profile_id': '51090133', 'profile_mid': '90787272', 'user_name': 'JIN QI FENG'}, {'profile_id': '51896067', 'profile_mid': '51732936', 'user_name': '金shanyu,'}, {'profile_id': '51887940', 'profile_mid': '155807574', 'user_name': '清溪'}, {'profile_id': '51870749', 'profile_mid': '151825539', 'user_name': '炳寅'}, {'profile_id': '51859708', 'profile_mid': '370150915', 'user_name': '柯汉荣'}, {'profile_id': '51867853', 'profile_mid': '306386778', 'user_name': '股市大涨'}, {'profile_id': '51844505', 'profile_mid': '308269218', 'user_name': '金焱'}, {'profile_id': '51858359', 'profile_mid': '1237516465', 'user_name': '福娃'}, {'profile_id': '51857228', 'profile_mid': '289803130', 'user_name': '孙荣诚'}, {'profile_id': '51848472', 'profile_mid': '218645099', 'user_name': 'Sesshu'}, {'profile_id': '51844684', 'profile_mid': '561884142', 'user_name': '清水老兵'}, {'profile_id': '51842161', 'profile_mid': '60635628', 'user_name': '扬帆'}, {'profile_id': '51838152', 'profile_mid': '272854142', 'user_name': '陈老师'}, {'profile_id': '51837690', 'profile_mid': '125210060', 'user_name': '众志成城'}, {'profile_id': '51835451', 'profile_mid': '1059441442', 'user_name': '我的小月亮'}, {'profile_id': '51833044', 'profile_mid': '34989248', 'user_name': '中国人'}, {'profile_id': '51830836', 'profile_mid': '444823093', 'user_name': '风雪春秋'}, {'profile_id': '51827354', 'profile_mid': '77161680', 'user_name': '百花争艳'}, {'profile_id': '51820497', 'profile_mid': '1107835923', 'user_name': '亮剑'}, {'profile_id': '51818933', 'profile_mid': '1192333173', 'user_name': '新竹'}, {'profile_id': '51816781', 'profile_mid': '272859981', 'user_name': '杨任妹'}, {'profile_id': '51809588', 'profile_mid': '195423984', 'user_name': '罗作仁'}, {'profile_id': '51806414', 'profile_mid': '101993464', 'user_name': '大晖'}, {'profile_id': '51796726', 'profile_mid': '37713557', 'user_name': '刘洋'}, {'profile_id': '51774129', 'profile_mid': '120514549', 'user_name': '朱方忠'}, {'profile_id': '51745549', 'profile_mid': '375829295', 'user_name': '微信用户'}, {'profile_id': '51733637', 'profile_mid': '67870053', 'user_name': '金秋年华'}, {'profile_id': '51723802', 'profile_mid': '190233506', 'user_name': '金猴哥'}, {'profile_id': '51879237', 'profile_mid': '1161593352', 'user_name': '花仙子'}, {'profile_id': '51870551', 'profile_mid': '1161593386', 'user_name': '黄成光光'}, {'profile_id': '51869561', 'profile_mid': '1160417257', 'user_name': 'Angel'}, {'profile_id': '51857694', 'profile_mid': '1160417142', 'user_name': '伤不起'}, {'profile_id': '51857240', 'profile_mid': '1161593402', 'user_name': '开心果'}, {'profile_id': '51852670', 'profile_mid': '1160417306', 'user_name': '雷晓文'}, {'profile_id': '51848955', 'profile_mid': '1160417359', 'user_name': '奋斗前程。'}, {'profile_id': '51848952', 'profile_mid': '1160417375', 'user_name': '忧愁'}, {'profile_id': '51848945', 'profile_mid': '1160417160', 'user_name': '杨杰'}, {'profile_id': '51848518', 'profile_mid': '1160417330', 'user_name': '洪云'}, {'profile_id': '51844574', 'profile_mid': '1163035519', 'user_name': '老苹果'}, {'profile_id': '51843482', 'profile_mid': '1160417296', 'user_name': '开心大熊'}, {'profile_id': '51820970', 'profile_mid': '1161593405', 'user_name': '心想事成'}, {'profile_id': '51831334', 'profile_mid': '4025570', 'user_name': '甲申'}, {'profile_id': '51764546', 'profile_mid': '1160417298', 'user_name': '艳阳天'}, {'profile_id': '51764199', 'profile_mid': '1160417196', 'user_name': '苍茫大地'}, {'profile_id': '51782247', 'profile_mid': '1227024290', 'user_name': '秋水伊人'}, {'profile_id': '51772563', 'profile_mid': '1160417253', 'user_name': '古淑君'}, {'profile_id': '51764224', 'profile_mid': '1161593373', 'user_name': '开心就好'}, {'profile_id': '51778122', 'profile_mid': '1160417223', 'user_name': '张南英'}, {'profile_id': '51749058', 'profile_mid': '1161593382', 'user_name': '勿相忘'}, {'profile_id': '51769042', 'profile_mid': '1161593400', 'user_name': '听雨听风'}, {'profile_id': '51792924', 'profile_mid': '1160417192', 'user_name': '涓涓细流'}, {'profile_id': '51729560', 'profile_mid': '1163021457', 'user_name': '春暖花开'}, {'profile_id': '51815073', 'profile_mid': '62490249', 'user_name': '魏长利'}, {'profile_id': '51764279', 'profile_mid': '1160417197', 'user_name': '白丽丽'}, {'profile_id': '51748003', 'profile_mid': '1161593371', 'user_name': '知足常乐'}, {'profile_id': '51795884', 'profile_mid': '114134599', 'user_name': '梅松'}, {'profile_id': '51792382', 'profile_mid': '44050852', 'user_name': '寒星~毕汉彬'}, {'profile_id': '51790852', 'profile_mid': '166613635', 'user_name': '汤友敏（远方的思念）'}, {'profile_id': '51788576', 'profile_mid': '140556589', 'user_name': '茫茫草原'}, {'profile_id': '51770146', 'profile_mid': '1160417254', 'user_name': '方明环保，万正刚'}, {'profile_id': '51745649', 'profile_mid': '1160417124', 'user_name': '甜点阿婆'}, {'profile_id': '51702476', 'profile_mid': '1161593367', 'user_name': '奋斗'}, {'profile_id': '51785204', 'profile_mid': '1158032765', 'user_name': '山河日月'}, {'profile_id': '51761700', 'profile_mid': '27308590', 'user_name': '陈国娟'}, {'profile_id': '51741652', 'profile_mid': '25942070', 'user_name': '时毛老太鞠春华.'}, {'profile_id': '51779816', 'profile_mid': '1161593383', 'user_name': '年年有余'}, {'profile_id': '51772245', 'profile_mid': '1161593418', 'user_name': '你还好吗'}, {'profile_id': '51768109', 'profile_mid': '1160417270', 'user_name': '冯秀华'}, {'profile_id': '51731821', 'profile_mid': '1161593417', 'user_name': '舍得'}, {'profile_id': '51793394', 'profile_mid': '135016737', 'user_name': '墨石'}, {'profile_id': '51792395', 'profile_mid': '148767050', 'user_name': '曹世'}, {'profile_id': '51776647', 'profile_mid': '52219485', 'user_name': '蜡烛'}, {'profile_id': '51738096', 'profile_mid': '399391491', 'user_name': '趙聚兴'}, {'profile_id': '51778123', 'profile_mid': '1160417284', 'user_name': '春色满园'}, {'profile_id': '51751245', 'profile_mid': '1161593376', 'user_name': '玉兰花'}, {'profile_id': '51730994', 'profile_mid': '1160417235', 'user_name': '秋天的思念'}, {'profile_id': '51697057', 'profile_mid': '1160417225', 'user_name': '谨言'}, {'profile_id': '51789829', 'profile_mid': '112075786', 'user_name': 'tree'}, {'profile_id': '51700173', 'profile_mid': '177738644', 'user_name': '茉莉'}, {'profile_id': '51776577', 'profile_mid': '914034946', 'user_name': '开心快乐'}, {'profile_id': '51771365', 'profile_mid': '1148891524', 'user_name': '樱花'}, {'profile_id': '51746428', 'profile_mid': '17175795', 'user_name': '卓必英'}, {'profile_id': '51600056', 'profile_mid': '1121939355', 'user_name': '权重镇'}, {'profile_id': '51771445', 'profile_mid': '1161593429', 'user_name': '海阔天空'}, {'profile_id': '51594733', 'profile_mid': '1160417234', 'user_name': '慧慧'}, {'profile_id': '51792710', 'profile_mid': '209764266', 'user_name': '倚竹聽風'}, {'profile_id': '51776028', 'profile_mid': '75908697', 'user_name': '展冲'}, {'profile_id': '51769357', 'profile_mid': '306658268', 'user_name': '笑傲夕阳。'}, {'profile_id': '51761052', 'profile_mid': '172537179', 'user_name': '紫璇'}, {'profile_id': '51758399', 'profile_mid': '209115412', 'user_name': '爱珍'}, {'profile_id': '51752520', 'profile_mid': '192722488', 'user_name': '陆正坦'}, {'profile_id': '51747614', 'profile_mid': '136319850', 'user_name': '飞虎'}, {'profile_id': '51742882', 'profile_mid': '314625934', 'user_name': '童心'}, {'profile_id': '51730346', 'profile_mid': '44321542', 'user_name': '高山石松'}, {'profile_id': '51719395', 'profile_mid': '20207787', 'user_name': '好景常在'}, {'profile_id': '51719188', 'profile_mid': '133189743', 'user_name': '发财树'}, {'profile_id': '51772723', 'profile_mid': '179517423', 'user_name': '宗臣'}, {'profile_id': '51660886', 'profile_mid': '520310946', 'user_name': '朱秀玉'}, {'profile_id': '51709037', 'profile_mid': '90231643', 'user_name': '声声亮果'}, {'profile_id': '51708204', 'profile_mid': '128794100', 'user_name': '涛餮'}, {'profile_id': '51701555', 'profile_mid': '154585163', 'user_name': '世雄'}, {'profile_id': '51700164', 'profile_mid': '283076815', 'user_name': '韩公'}]

        return user_list

    # 获取个人主页视频
    @classmethod
    def get_videoList(cls, log_type, crawler, strategy, p_mid, oss_endpoint, env):
        try:
            while True:
                url = "https://api.xiaoniangao.cn/profile/list_album"
                headers = {
                    # "X-Mid": str(cls.follow_x_mid),
                    "X-Mid": '1fb47aa7a860d9',
                    # "X-Token-Id": str(cls.follow_x_token_id),
                    "X-Token-Id": '9f2cb91f9952c107ecb73642083e1dec-1145266232',
                    "content-type": "application/json",
                    # "uuid": str(cls.follow_uid),
                    "uuid": 'f40c2e7c-3cfb-4804-b513-608c0280268c',
                    "Accept-Encoding": "gzip,compress,br,deflate",
                    "User-Agent": "Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)"
                                  " AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 "
                                  "MicroMessenger/8.0.20(0x18001435) NetType/WIFI Language/zh_CN",
                    # "Referer": str(cls.follow_referer)
                    "Referer": 'https://servicewechat.com/wxd7911e4c177690e4/654/page-frame.html'
                }
                json_text = {
                    "visited_mid": str(p_mid),
                    "start_t": cls.next_t,
                    "qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!690x385r/crop/690x385/interlace/1/format/jpg",
                    "h_qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!120x120r/crop/120x120/interlace/1/format/jpg",
                    "limit": 20,
                    # "token": str(cls.follow_token),
                    "token": '54e4c603f7bf3dc009c86b49ed91be36',
                    # "uid": str(cls.follow_uid),
                    "uid": 'f40c2e7c-3cfb-4804-b513-608c0280268c',
                    "proj": "ma",
                    "wx_ver": "8.0.23",
                    "code_ver": "3.68.0",
                    "log_common_params": {
                        "e": [{
                            "data": {
                                "page": "profilePage",
                                "topic": "public"
                            }
                        }],
                        "ext": {
                            "brand": "iPhone",
                            "device": "iPhone 11",
                            "os": "iOS 14.7.1",
                            "weixinver": "8.0.23",
                            "srcver": "2.24.7",
                            "net": "wifi",
                            "scene": "1089"
                        },
                        "pj": "1",
                        "pf": "2",
                        "session_id": "7468cf52-00ea-432e-8505-6ea3ad7ec164"
                    }
                }
                urllib3.disable_warnings()
                r = requests.post(url=url, headers=headers, json=json_text, proxies=proxies, verify=False)
                if 'data' not in r.text or r.status_code != 200:
                    Common.logger(log_type, crawler).info(f"get_videoList:{r.text}\n")
                    cls.next_t = None
                    return
                elif 'list' not in r.json()['data']:
                    Common.logger(log_type, crawler).info(f"get_videoList:{r.json()}\n")
                    cls.next_t = None
                    return
                elif len(r.json()['data']['list']) == 0:
                    Common.logger(log_type, crawler).info(f"没有更多数据啦~\n")
                    cls.next_t = None
                    return
                else:
                    cls.next_t = r.json()["data"]["next_t"]
                    feeds = r.json()["data"]["list"]
                    for i in range(len(feeds)):
                        # 标题，表情随机加在片头、片尾，或替代句子中间的标点符号
                        char_sheet = [['📍', '...'], ['⭕️', '~~'], ['🔥', None], ['📣', None], ['🎈', None], ['⚡', None], ['🔔', None], ['🚩', None], ['💢', None], ['💎', None], ['👉', None], ['💓', None], ['❗️', None], ['🔴', None], ['🔺', None], ['♦️', None], ['♥️', None], ['👉', None], ['👈', None], ['🏆', None], ['❤️\u200d🔥', None]]
                        expression_list = []
                        char_list = []
                        for q in range(len(char_sheet)):
                            if char_sheet[q][0] is not None:
                                expression_list.append(char_sheet[q][0])
                            if char_sheet[q][1] is not None:
                                char_list.append(char_sheet[q][1])
                        befor_video_title = feeds[i]["title"].strip().replace("\n", "") \
                            .replace("/", "").replace("\r", "").replace("#", "") \
                            .replace(".", "。").replace("\\", "").replace("&NBSP", "") \
                            .replace(":", "").replace("*", "").replace("？", "") \
                            .replace("?", "").replace('"', "").replace("<", "") \
                            .replace(">", "").replace("|", "").replace(" ", "")
                        expression = random.choice(expression_list)
                        expression_title_list = [expression + befor_video_title, befor_video_title + expression]
                        # 标题，表情随机加在片头
                        title_list1 = random.choice(expression_title_list)
                        # 标题，表情随机加在片尾
                        title_list2 = befor_video_title + random.choice(char_list)
                        # # 替代句子中间的标点符号
                        # title_list3 = befor_video_title.replace(
                        #     ",", random.choice(expression_list)).replace("，", random.choice(expression_list))
                        title_list4 = [title_list1, title_list2]
                        video_title = random.choice(title_list4)

                        # 用户名
                        user_name = feeds[i]["album_user"]["nick"].strip().replace("\n", "") \
                            .replace("/", "").replace("快手", "").replace(" ", "") \
                            .replace(" ", "").replace("&NBSP", "").replace("\r", "")

                        # 视频 ID
                        if "vid" in feeds[i]:
                            video_id = feeds[i]["vid"]
                        else:
                            video_id = 0

                        # 播放量
                        if "play_pv" in feeds[i]:
                            video_play_cnt = feeds[i]["play_pv"]
                        else:
                            video_play_cnt = 0

                        # 点赞
                        if "total" in feeds[i]["favor"]:
                            video_like_cnt = feeds[i]["favor"]["total"]
                        else:
                            video_like_cnt = 0

                        # 评论数
                        if "comment_count" in feeds[i]:
                            video_comment_cnt = feeds[i]["comment_count"]
                        else:
                            video_comment_cnt = 0

                        # 分享
                        if "share" in feeds[i]:
                            video_share_cnt = feeds[i]["share"]
                        else:
                            video_share_cnt = 0

                        # 时长
                        if "du" in feeds[i]:
                            video_duration = int(feeds[i]["du"] / 1000)
                        else:
                            video_duration = 0

                        # 发布时间
                        if "t" in feeds[i]:
                            publish_time_stamp = int(feeds[i]["t"] / 1000)
                        else:
                            publish_time_stamp = 0
                        publish_time_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(publish_time_stamp))

                        # 宽和高
                        if "w" in feeds[i] or "h" in feeds[i]:
                            video_width = feeds[i]["w"]
                            video_height = feeds[i]["h"]
                        else:
                            video_width = 0
                            video_height = 0

                        # 头像
                        if "hurl" in feeds[i]["album_user"]:
                            head_url = feeds[i]["album_user"]["hurl"]
                        else:
                            head_url = 0

                        # 用户 ID
                        if "id" in feeds[i]:
                            profile_id = feeds[i]["id"]
                        else:
                            profile_id = 0

                        # 用户 mid
                        if "mid" in feeds[i]:
                            profile_mid = feeds[i]["mid"]
                        else:
                            profile_mid = 0

                        # 封面
                        if "url" in feeds[i]:
                            cover_url = feeds[i]["url"]
                        else:
                            cover_url = 0

                        # 视频播放地址
                        if "v_url" in feeds[i]:
                            video_url = feeds[i]["v_url"]
                        else:
                            video_url = 0

                        # 过滤无效视频
                        if video_id == 0 \
                                or video_title == 0 \
                                or publish_time_stamp == 0 \
                                or video_duration == 0 \
                                or video_url == 0:
                            Common.logger(log_type, crawler).info("无效视频\n")
                        elif int(time.time()) - publish_time_stamp > 3600 * 24 * 3:
                            Common.logger(log_type, crawler).info(f"发布时间超过3天:{publish_time_str}\n")
                            cls.next_t = None
                            return
                        else:
                            video_dict = {
                                "video_id": video_id,
                                "video_title": video_title,
                                "duration": video_duration,
                                "play_cnt": video_play_cnt,
                                "like_cnt": video_like_cnt,
                                "comment_cnt": video_comment_cnt,
                                "share_cnt": video_share_cnt,
                                "user_name": user_name,
                                "publish_time_stamp": publish_time_stamp,
                                "publish_time_str": publish_time_str,
                                "video_width": video_width,
                                "video_height": video_height,
                                "avatar_url": head_url,
                                "profile_id": profile_id,
                                "profile_mid": profile_mid,
                                "cover_url": cover_url,
                                "video_url": video_url,
                                "session": f"xiaoniangao-follow-{int(time.time())}"
                            }
                            for k, v in video_dict.items():
                                Common.logger(log_type, crawler).info(f"{k}:{v}")
                            cls.download_publish(log_type=log_type,
                                                 crawler=crawler,
                                                 strategy=strategy,
                                                 video_dict=video_dict,
                                                 oss_endpoint=oss_endpoint,
                                                 env=env)
        except Exception as error:
            Common.logger(log_type, crawler).error(f"获取个人主页视频异常:{error}\n")

    @classmethod
    def repeat_video(cls, log_type, crawler, video_id, env):
        sql = f""" select * from crawler_video where platform="小年糕" and out_video_id="{video_id}"; """
        repeat_video = MysqlHelper.get_values(log_type, crawler, sql, env)
        return len(repeat_video)

    # 下载/上传
    @classmethod
    def download_publish(cls, log_type, crawler, strategy, video_dict, oss_endpoint, env):
        try:
            if cls.download_rule(video_dict) is False:
                Common.logger(log_type, crawler).info("不满足基础门槛\n")
            elif cls.repeat_video(log_type, crawler, video_dict['video_id'], env) != 0:
                Common.logger(log_type, crawler).info('视频已下载\n')
            elif any(str(word) if str(word) in video_dict['video_title'] else False for word in filter_word(log_type, crawler, "小年糕", env)) is True:
                Common.logger(log_type, crawler).info("视频已中过滤词\n")
            else:
                # 下载封面
                Common.download_method(log_type=log_type, crawler=crawler, text="cover",
                                       title=video_dict["video_title"], url=video_dict["cover_url"])
                # 下载视频
                Common.download_method(log_type=log_type, crawler=crawler, text="video",
                                       title=video_dict["video_title"], url=video_dict["video_url"])
                # 保存视频信息至 "./videos/{download_video_title}/info.txt"
                Common.save_video_info(log_type=log_type, crawler=crawler, video_dict=video_dict)

                # 上传视频
                Common.logger(log_type, crawler).info("开始上传视频...")
                our_video_id = Publish.upload_and_publish(log_type=log_type,
                                                          crawler=crawler,
                                                          strategy=strategy,
                                                          our_uid="follow",
                                                          env=env,
                                                          oss_endpoint=oss_endpoint)
                if env == "dev":
                    our_video_link = f"https://testadmin.piaoquantv.com/cms/post-detail/{our_video_id}/info"
                else:
                    our_video_link = f"https://admin.piaoquantv.com/cms/post-detail/{our_video_id}/info"
                Common.logger(log_type, crawler).info("视频上传完成")

                if our_video_id is None:
                    # 删除视频文件夹
                    shutil.rmtree(f"./{crawler}/videos/{video_dict['video_title']}")
                    return

                # 视频信息保存数据库
                rule_dict = {
                    "duration": {"min": 40, "max": 100000000},
                    "play_cnt": {"min": 500}
                }

                insert_sql = f""" insert into crawler_video(video_id,
                                                out_user_id,
                                                platform,
                                                strategy,
                                                out_video_id,
                                                video_title,
                                                cover_url,
                                                video_url,
                                                duration,
                                                publish_time,
                                                play_cnt,
                                                crawler_rule,
                                                width,
                                                height)
                                                values({our_video_id},
                                                "{video_dict['profile_id']}",
                                                "{cls.platform}",
                                                "定向爬虫策略",
                                                "{video_dict['video_id']}",
                                                "{video_dict['video_title']}",
                                                "{video_dict['cover_url']}",
                                                "{video_dict['video_url']}",
                                                {int(video_dict['duration'])},
                                                "{video_dict['publish_time_str']}",
                                                {int(video_dict['play_cnt'])},
                                                '{json.dumps(rule_dict)}',
                                                {int(video_dict['video_width'])},
                                                {int(video_dict['video_height'])}) """
                Common.logger(log_type, crawler).info(f"insert_sql:{insert_sql}")
                MysqlHelper.update_values(log_type, crawler, insert_sql, env)
                Common.logger(log_type, crawler).info('视频信息插入数据库成功！')

                # 视频写入飞书
                Feishu.insert_columns(log_type, crawler, "Wu0CeL", "ROWS", 1, 2)
                # 视频ID工作表，首行写入数据
                upload_time = int(time.time())
                values = [[time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(upload_time)),
                           "用户主页",
                           str(video_dict['video_id']),
                           str(video_dict['video_title']),
                           our_video_link,
                           video_dict['play_cnt'],
                           video_dict['comment_cnt'],
                           video_dict['like_cnt'],
                           video_dict['share_cnt'],
                           video_dict['duration'],
                           f"{video_dict['video_width']}*{video_dict['video_height']}",
                           str(video_dict['publish_time_str']),
                           str(video_dict['user_name']),
                           str(video_dict['profile_id']),
                           str(video_dict['profile_mid']),
                           str(video_dict['avatar_url']),
                           str(video_dict['cover_url']),
                           str(video_dict['video_url'])]]
                time.sleep(1)
                Feishu.update_values(log_type, crawler, "Wu0CeL", "F2:Z2", values)
                Common.logger(log_type, crawler).info('视频信息写入飞书成功\n')

        except Exception as e:
            Common.logger(log_type, crawler).error("下载/上传异常:{}", e)

    # 获取所有关注列表的用户视频
    @classmethod
    def get_follow_videos(cls, log_type, crawler, strategy, oss_endpoint, env):
        try:
            # 已关注的用户列表 mids
            user_list = cls.get_users()
            for user in user_list:
                user_name = user['user_name']
                profile_mid = user['profile_mid']
                Common.logger(log_type, crawler).info(f"获取 {user_name} 主页视频")
                cls.get_videoList(log_type=log_type,
                                  crawler=crawler,
                                  strategy=strategy,
                                  p_mid=profile_mid,
                                  oss_endpoint=oss_endpoint,
                                  env=env)
                cls.next_t = None
                time.sleep(1)
        except Exception as e:
            Common.logger(log_type, crawler).error(f"get_follow_videos:{e}\n")


if __name__ == "__main__":
    # print(XiaoniangaoFollow.repeat_video("follow", "xiaoniangao", "4919087666", "prod", "aliyun"))
    # print(XiaoniangaoFollow.repeat_video("follow", "xiaoniangao", "4919087666", "dev"))
    XiaoniangaoFollow.get_users()
    pass
